#
#    Program E
#    Copyright 2002, Paul Rydell
#	
#    This file is part of Program E.
#	
#    Program E is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    Program E is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Program E; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

#
# Table structure for table 'bot'
#

CREATE TABLE bot (
  name varchar(255) NOT NULL default '',
  value text NOT NULL
) TYPE=MyISAM;

#
# Table structure for table 'conversationlog'
#

CREATE TABLE conversationlog (
  id int(11) NOT NULL auto_increment,
  input text,
  response text,
  thatresponse text,
  uid varchar(255) default NULL,
  enteredtime timestamp(14) not null,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'dstore'
#

CREATE TABLE dstore (
  uid varchar(255) default NULL,
  name text,
  value text,
  enteredtime timestamp(14) not null,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'gossip'
#

CREATE TABLE gossip (
  gossip text,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'patterns'
#

CREATE TABLE patterns (
  id int(11) NOT NULL default '0',
  word varchar(255) default NULL,
  ordera tinyint(4) NOT NULL default '0',
  parent int(11) NOT NULL default '0',
  isend tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id (id),
  KEY wordparent (parent,word)
) TYPE=MyISAM;

#
# Table structure for table 'templates'
#

CREATE TABLE templates (
  id int(11) NOT NULL default '0',
  template text NOT NULL,
  KEY id (id)
) TYPE=MyISAM;

#
# Table structure for table 'thatindex'
#

CREATE TABLE thatindex (
  uid varchar(255) default NULL,
  enteredtime timestamp(14) not null,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Table structure for table 'thatstack'
#

CREATE TABLE thatstack (
  thatid int(11) NOT NULL default '0',
  id int(11) NOT NULL auto_increment,
  value varchar(255) default NULL,
  enteredtime timestamp(14) not null,
  PRIMARY KEY  (id)
) TYPE=MyISAM;


CREATE TABLE gmcache (
  template text,
  inputstarvals text,
  thatstarvals text,
  topicstarvals text,
  patternmatched text,
  inputmatched text, 
  combined text not null,
  primary key(combined(255))
) TYPE=MyISAM;

